## DAC 说明

注意：任何应用只能是输出数字信号，无法输出模拟信号。

数字信号只能通过硬件转换为模拟信号（以电流、电压或电荷的形式）从而让用户听见声音。这个硬件就叫做 DAC，Digital to analog converter，数字模拟转换器，将数字信号转换为模拟信号（以电流、电压或电荷的形式）。

数字信号两个重要参数，采样率和比特率，椒盐音乐在 AAduio 可以输出极高的采样率和最高 32 位深的数字信号（AudioTrack 模式下最高采样率由设备支持指定）。

但是在安卓音频系统上不仅仅是你一个软件要输出音频，其他的软件也需要，就像你听歌（音频焦点逻辑对此无影响）时候突然支付宝到账一亿元，两者的声音是要经过重新采样（SRC）至 48 千赫兹和 16 位深（一般情况，有些手机设备支持更高），最后安卓通过混音器混合每个经过重新采样的音频（此时还是数字信号）交给 DAC 硬件。

那么普通耳机和 USB 耳机有什么区别呢？

上面说到安卓通过混音器合音频，此时音质都是确定的，两者区别不产生在此！

先来了解下外放，就是上方混合后的音频通过手机自带的 DAC 硬件转换为模拟信号在传给扬声器输出。差的 DAC 硬件输出的效果就差，好的输出就好。（也有很多受手机内部空间影响，元器件密集造成底噪严重）。

再来看耳机：

模拟耳机：一般为 3.5 mm 接口耳机，它不自带 DAC ，它的作用其实就是代替手机的扬声器。

数组耳机：USB 数字耳机，自带 DAC ，那么就不需要安卓自带的 DAC 硬件了。

所以明确一个流程：音频文件 -- 应用程序 --> 数字信号 -- DAC --> 模拟信号。



## USB 独占

`说明：椒盐音乐暂时还不支持独占 USB ，下面仅解释下独占原理。`

原理是应用工作在 USB 独占模式时，直接把数字信号输送给 USB 系统，通过 USB 接口输送给数字 USB 耳机。它避开 Android 音频系统，但是会使得 Android 音频系统的声音无法输送到 USB 系统，因为 USB 系统本身不含有 Mixer（混音器），所以此时手机上其他应用都是没有声音的。

结论：

数字 USB 耳机只接受数字信号，不使用数字 USB 耳机，其他耳机是不存在内部 DAC 的情况。不存在所谓的“全局 DAC ”模式，USB 独占模式只是绕过了安卓的音频重新采样和混音系统，必然会导致其他应用无声。

所以当应用没实现独占 USB ，应用能做的，最大做到的只有以最好的品质输出数字信号（椒盐音乐目前应该完成了这一点），而其他软件能超过的应该只有一个，独占 USB。所以需要设备或者说设备系统提高安卓重采样品质和混音效果。如小米 10 的音频表现很棒~

参考谷歌关于高性能音频说明、小米技术解释图等。

综上，你的设备决定上限，而音乐软件只要输出的品质达到你的设备上限就无法提高了（当然你音频文件要支持这么高）。独占 USB 可以提高设备上限，任何没有独占 USB 的音乐软件 100% 会输送到安卓音频系统（SRC + Mixer），独占 USB 必然其他软件无声。在此针对椒盐音乐和所有没独占 USB 的音乐软件。

以上说明仅代表椒盐音乐开发者。可能有所错误，请指正~

联系开发者：Moriafly@163.com ，祝使用愉快~
